Summary:        The Mozilla Firefox project is a redesign of Mozilla's browser
Name:           firefox
Version:        0.8
Release:       	alt4
License:        MPL
Group:          Networking/WWW
URL:            http://www.mozilla.org/projects/firefox/

Source0:        %name-source-%version.tar.bz2
Source1:        %name-icons.tar.bz2
Source2:        customize-doc-20040113.tar.bz2
Source3:        %name-build-scripts.tar.bz2
Source4:        rpm.macros.%name
Source5:        %name-rebuild-databases.sh
Source6: 	.mozconfig-firefox
Source7: 	%name-searchplugins.tar.bz2

# Default home page 
Patch1:		%name-browser-home-page.patch
# Add '.firefox' to plugins search 
Patch2:		%name-plugindirs.patch
# Change product name
Patch3:		%name-productname.patch
# Some changes at run-mozilla.sh script
Patch4:		%name-run-mozilla.patch
# Build fix 
Patch5:		%name-configure_in.patch
# Add defailt ALT Linux splash (thx sadist@)
Patch6:		%name-altlinux-splash.patch

# Automatically added by buildreq on Wed Dec 31 2003
BuildRequires: XFree86-devel-static XFree86-libs fontconfig-devel freetype2-devel 
BuildRequires: gcc-c++ glib2-devel libIDL-devel libatk-devel libgtk+2-devel 
BuildRequires: libjpeg-devel libpango-devel libpng-devel libstdc++-devel pkgconfig 
BuildRequires: unzip zip zlib-devel

Requires:	gtk+2 >= 2.2.0 freetype2
Requires:	indexhtml

Provides:	MozillaFirebird
Obsoletes:	MozillaFirebird

%define fullname		%name-%version
%define firefox_prefix  	%_libdir/%name
%define firefox_chromedir	%firefox_prefix/chrome

%description
The Mozilla Firefox project is a redesign of Mozilla's browser component,
written using the XUL user interface language and designed to be
cross-platform.

%package devel
Requires: %name = %version-%release
Summary: MozillaFirebird development files
Group: Development/Other

Provides:  MozillaFirebird-devel
Obsoletes: MozillaFirebird-devel

%description devel
MozillaFirebird development files

%prep
%setup -q -nmozilla 
%setup -q -nmozilla -T -D -a1
%setup -q -nmozilla -T -D -a2
%setup -q -nmozilla -T -D -a3

%patch1 -p1 -b .browser-home-page
%patch2 -p1 -b .plugindirs
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1

# change .mozconfig
%__cp -f %SOURCE6 ./.mozconfig

%build
%add_optflags %optflags_shared
%add_findprov_lib_path %_libdir/%fullname
export MOZ_PHOENIX=1 MOZILLA_OFFICIAL=1 BUILD_OFFICIAL=1
export LIBIDL_CONFIG=/usr/bin/libIDL-config-2

%configure \
     --prefix=%_prefix \
     --includedir=%_includedir/%name \
     --disable-tests \
     --disable-debug \
     --disable-logging \
     --disable-xprint \
     --disable-mailnews \
     --disable-composer \
     --disable-freetype2 \
     --enable-ldap \
     --enable-jsd \
     --enable-xft \
     --enable-crypto \
     --enable-extensions=pref,cookie,xmlextras,universalchardet,typeaheadfind \
     --enable-necko-protocols=all \
     --enable-default-toolkit=gtk2 \
     --enable-optimize="-O3" \
     --enable-reorder \
     --enable-elf-dynstr-gc \
     --enable-strip \
     --enable-shared \
     --with-system-jpeg \
     --with-system-png \
     --with-system-mng \
     --with-system-zlib \
     --with-pthreads \
     --with-user-appdir=.firefox

#--enable-extensions=cookie,xml-rpc,xmlextras,p3p,pref,transformiix,universalchardet,typeaheadfind,webservices \
#--enable-extensions=pref,cookie,wallet 

%make_build \
    prefix=%_prefix \
    idldir=%_datadir/idl/%name \
    mozappdir=%_libdir/%fullname \
    MOZ_PHOENIX=1 

%install
%makeinstall \
    idldir=%buildroot/%_datadir/idl/%name \
    includedir=%buildroot/%_includedir/%name \
    mozappdir=%buildroot/%_libdir/%fullname \
    MOZ_PHOENIX=1 

# make package link 
%__ln_s %fullname %buildroot%_libdir/%name

# Menu
mkdir -p %buildroot/%_menudir
cat > %buildroot/%_menudir/%name << EOF
?package(%name): \
command="%_bindir/%name" \
needs="X11" \
icon="%name.png" \
section="Networking/WWW" \
title="Mozilla Firefox" \
longtitle="The Mozilla Firefox project is a redesign of Mozilla's browser"
EOF

# icons
%__install -D -m 644 %name-48.png %buildroot/%_liconsdir/%name.png
%__install -D -m 644 %name-32.png %buildroot/%_iconsdir/%name.png
%__install -D -m 644 %name-16.png %buildroot/%_miconsdir/%name.png

# Add search plugins
cd %buildroot/%_libdir/%name
  %__tar jxvf %SOURCE7
cd -

# RPM MACRO
%__mkdir_p %buildroot%_sysconfdir/rpm/macros.d
%__cp %SOURCE4 %buildroot%_sysconfdir/rpm/macros.d/%name

# move Firefox stuff
%__mkdir_p %buildroot/%_libdir/%fullname
%__install -D -m 700 %SOURCE5 %buildroot/%_libdir/%fullname/rebuild-databases.sh

# Add language to list.
echo 'en-US' > %buildroot/%_libdir/%fullname/chrome/language

# We must rename some file to remove comflicts between Mozilla, Firefox and Thunderbird pckages. 
%__mv %buildroot/%_bindir/mozilla-config %buildroot/%_bindir/%name-config
%__subst 's@\(/include/%name/\)[^\/\"]*\/\?\(.*\)@\1\2@' %buildroot/%_bindir/%name-config

for f in $(find %buildroot/%_libdir/pkgconfig -name 'mozilla-*'); do
%__mv -f $f %buildroot/%_libdir/pkgconfig/%name-${f##*/mozilla-} 
%__subst 's@\(/include/%name/\)[^\/\"]*\/\?\(.*\)@\1\2@' %buildroot/%_libdir/pkgconfig/%name-${f##*/mozilla-} 
done
for f in $(find %buildroot/%_datadir/aclocal -type f); do
%__mv -f $f %buildroot/%_datadir/aclocal/%name-${f##*/} 
done

# make backup installed-chrome.txt to make possible addons installion
%__cp -p %buildroot/%_libdir/%fullname/chrome/installed-chrome.txt \
	    %buildroot/%_libdir/%fullname/chrome/installed-chrome-%name.txt

# make devel source packege to build extensions
%__mkdir_p %buildroot/%_usrsrc/%name
find %buildroot/%_libdir/%name \
     %buildroot/%_includedir/%name \
     %buildroot/%_datadir/idl/%name \
-follow -xtype f |sed 's,^%buildroot/\(.*\)$,\1,' > ./%name-content-index

%__tar -jcf %buildroot/%_usrsrc/%name/sources.tar.bz2 \
    ./makemake.sh ./build_dist.sh find_install.sh      \
    ./%name-content-index                              \
    ./build                                            \
    ./config                                           \
    ./browser                                          \
    ./.mozconfig                                       \
    ./mozilla-config.h

%post 
%post_ldconfig
%update_menus
umask 022 
%__cat %firefox_chromedir/installed-chrome-*.txt > %firefox_chromedir/installed-chrome.txt 
%firefox_prefix/rebuild-databases.sh

%postun
%postun_ldconfig
%clean_menus

%files 
%_bindir/%name
%_libdir/%name
%_libdir/%fullname
%defattr(0644,root,root,0755)
%_menudir/*
%_iconsdir/*.png
%_miconsdir/*
%_liconsdir/*
%doc LEGAL LICENSE README.txt browser/README.html
%doc customize-doc

%files devel
%_sysconfdir/rpm/macros.d/%name
%_bindir/%name-config
%_includedir/%name
%_datadir/aclocal/*
%_datadir/idl/%name
%_libdir/pkgconfig/*
%_usrsrc/%name

%changelog
* Fri May 28 2004 Alexey Gladkov <legion@altlinux.ru> 0.8-alt4
- Move back some changes at alt3 build.
- Bug #4157 fixed.

* Fri Apr 30 2004 Alexey Gladkov <legion@altlinux.ru> 0.8-alt3.1
- viewsource protocol was added.

* Thu Apr 29 2004 Alexey Gladkov <legion@altlinux.ru> 0.8-alt3
- Minimize buildin extensions;
- Disable debug output;
- Disable some options:
  + disable JavaScript debug library;
  + disable LDAP support;
  + disable logging facilities;
- Necko protocols cleanup;

* Tue Feb 24 2004 Alexey Gladkov <legion@altlinux.ru> 0.8-alt2
- Splash screen added (thx sadist@);
- Search plugins added;
- Remove devel package Conflicts;
- Change rebuild-database.sh script. Script must be run only as root;
- Change locale hack.

* Wed Feb 11 2004 Alexey Gladkov <legion@altlinux.ru> 0.8-alt1
- Mozilla Firebird becomes Mozilla Firefox. Mozilla's next 
  generation browser has changed names (again);
- New version;

* Sun Jan 11 2004 Alexey Gladkov <legion@altlinux.ru> 0.7-alt2
- Spec changes.
- run-mozilla.sh script patch.

* Tue Dec 30 2003 Alexey Gladkov <legion@altlinux.ru> 0.7-alt1
- first build for ALT Linux.
- rpm macro created.
- new scheme loading extensions added (thx force@)
